require 'cacheurl'

class Latlng
	attr_accessor :lat
	attr_accessor :lng
	
	def initialize(lat = nil,lng = nil)
		@lat = lat
		@lng = lng
	
	end
	
	def MeshCode()
		mx1 = (@lng - 100).to_i
		my1 = (@lat * 1.5).to_i
		
		mx2 = ((@lng - lng.to_i) * 8).to_i;
		my2 = (((@lat * 1.5) - my1) * 8).to_i;
		
		return mx1.to_s + my1.to_s + mx2.to_s + my2.to_s;
	end

end 

class DTokyo < Latlng
	
	def toWorld()
		wlatlng = DWorld.new;
		wlatlng.lat = @lat - 0.00010695 * @lat + 0.000017464 * @lng + 0.0046017
		wlatlng.lng = @lng - 0.000046038 * @lat - 0.000083043 * @lng + 0.010040

		return wlatlng
	end
end

class DWorld < Latlng
	
	def toTokyo()
		tlatlng = DTokyo.new
		tlatlng.lat = @lat - 0.00010696 * @lat + 0.000017467 * @lng + 0.0046020
		tlatlng.lng = @lng - 0.000046047 * @lat - 0.000083049 * @lng + 0.010041
		return tlatlng
	end
end


class MapService
	attr_accessor :url
	def initialize(url)
		@url = url
	end
	
	def toWorld()
	end
	
	def toTokyo()
	end
	
end

class YahooMap < MapService
	
	def toWorld()
		
		tlatlng = parse
		return tlatlng.toWorld()
		
	end

	def toTokyo()
		tlatlng = parse
		return tlatlng
	end

	def parse()
	
		tlatlng = DTokyo.new
		
		if /CE\.x=([0-9]+?)&?/ =~ @url
			cu = CacheUrl.new("date","cache")
			ymwork = cu.get(@url)["contents"].toutf8
			
			if /URL：<\/b><a href="(.+?)">/ =~ ymwork
				ymurl = $1
			else
				ymurl = @url
			end
		else
			ymurl = @url
		end
		ymurl = ymurl.gsub(/\//,".")
		
		if /nl=([0-9]+?)\.([0-9]+?)\.([0-9]+\.*[0-9]*)&/ =~ymurl
			tlatlng.lat = $1.to_i
			tlatlng.lat = tlatlng.lat + ($2.to_i).to_f / 60
			tlatlng.lat = tlatlng.lat + $3.to_f / 3600
			
			if /el=([0-9]+?)\.([0-9]+?)\.([0-9]+\.*[0-9]*)&/ =~ymurl
				tlatlng.lng = $1.to_i
				tlatlng.lng = tlatlng.lng + ($2.to_i).to_f / 60
				tlatlng.lng = tlatlng.lng + $3.to_f / 3600
			end
		end
		
		return tlatlng
	end
	private :parse
end
