#!/usr/local/bin/ruby -Ku
require 'kconv'
require 'cacheurl'
require 'geoloc'
require 'cgi'
require "rexml/document"

JALAN_API_URL = 'http://jws.jalan.net/APILite/HotelSearch/V1/'
GET_HOTEL_COUNT = 100

print "Content-type: text/javascript\n\n"

def getJalanData(s_area)
	
	hotels = Array.new
	
	start = 1
	loop{
		url = JALAN_API_URL + "?key=guest&s_area=" +
			 s_area + "&count=" + GET_HOTEL_COUNT.to_s + "&start=" + start.to_s
		
		retdata = readWebPage(url)
		
		if retdata["code"] == "200" || retdata["code"] == "304"
					resultCount = perseJalanData(retdata["contents"].toutf8,hotels)
		else 
			break
		end
		
		if (start += GET_HOTEL_COUNT) > resultCount
			break
		end
	}
	print "[" + hotels.join(",") + "]"
end

def readWebPage(url)
	cu = CacheUrl.new("date","cache")
	return cu.get(url)
end

def perseJalanData(xmldocument,hotels)
	
	root = REXML::Document.new( xmldocument ).root
	
	root.elements.each("Hotel"){|rec|
		hotel = "{"
		hotel += "HotelID:'" + rec.text("HotelID") + "'"
		hotel += ",HotelName:'"+ rec.text("HotelName") + "'"
		hotel += ",PostCode:'" + rec.text("PostCode") + "'"
		hotel += ",HotelAddress:'" + rec.text("HotelAddress") + "'"
		hotel += ",HotelType:'" + rec.text("HotelType") + "'"
		hotel += ",HotelDetailURL:'" + rec.text("HotelDetailURL") + "'"
		hotel += ",HotelCatchCopy:'" + rec.text("HotelCatchCopy") + "'"
		hotel += ",HotelCaption:'" + rec.text("HotelCaption") + "'"
		if(rec.text("PictureURL"))
			hotel += ",PictureURL:'" + rec.text("PictureURL") + "'"
		end
		if(rec.text("PictureCaption"))
			hotel += ",PictureCaption:'" + rec.text("PictureCaption") + "'"
		end
		if(rec.text("X") != "999999999" && rec.text("X") != nil )
			dtky = DTokyo.new((rec.text("Y").to_f / 3600000),(rec.text("X").to_f / 3600000))
			dwld = dtky.toWorld()
			hotel += ",X:" + (dwld.lng).to_s
			hotel += ",Y:" + (dwld.lat).to_s
		end
		hotel += "}"
		hotels.push(hotel)
	}
	return root.text("NumberOfResults").to_i
end
cgi = CGI.new

if(cgi['c'])
	s_area = cgi['c'].toutf8
	
	if /([0-9]+)/ =~ s_area
		s_area = $1
		getJalanData(s_area)
	else
		print "[]"
	end
end


