#!/usr/local/bin/ruby -Ku
require 'kconv'
require 'cacheurl'
require "rexml/document"

JALAN_LOC_URL = 'http://jws.jalan.net/content/data/area.xml'
GET_HOTEL_COUNT = 100

print "Content-type: text/javascript\n\n"

def getJalanData()
	
	hotels = Array.new
	
	retdata = readWebPage(JALAN_LOC_URL)
	
	if retdata["code"] == "200" || retdata["code"] == "304"
		perseJalanLocData(retdata["contents"].toutf8)
	end
end

def readWebPage(url)
	cu = CacheUrl.new("date","cache")
	return cu.get(url)
end

def perseJalanLocData(xmldocument)
	
	root = REXML::Document.new( xmldocument ).root
	sepPref = ""
	root.elements.each("Prefecture"){|pref|
		print sepPref
		print "{"
		print "cd:'" + pref.attributes["cd"]  + "'"
		print ",name:'" + pref.attributes["name"] + "'"
		print ",LargeArea:["
		sepLarea = ""
		pref.elements.each("LargeArea"){|larea|
			print sepLarea
			print "{"
			print "cd:'" + larea.attributes["cd"]  + "'"
			print ",name:'" + larea.attributes["name"] + "'"
			print ",SmallArea:["
			sepSarea = ""
			larea.elements.each("SmallArea"){|sarea|
				print sepSarea
				print "{"
				print "cd:'" + sarea.attributes["cd"]  + "'"
				print ",name:'" + sarea.attributes["name"] + "'"
				print "}"
				sepSarea = ","
			}
			print "]}"
			sepLarea = ","
		}
		print "]}"
		sepPref = ","
	}
end
	print "["
	getJalanData()
	print "]"

